/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	"gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated_ambassador/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type GetambassadorV1Interface interface {
	RESTClient() rest.Interface
	KubernetesEndpointResolversGetter
	MappingsGetter
	TLSContextsGetter
}

// GetambassadorV1Client is used to interact with features provided by the getambassador.io group.
type GetambassadorV1Client struct {
	restClient rest.Interface
}

func (c *GetambassadorV1Client) KubernetesEndpointResolvers(namespace string) KubernetesEndpointResolverInterface {
	return newKubernetesEndpointResolvers(c, namespace)
}

func (c *GetambassadorV1Client) Mappings(namespace string) MappingInterface {
	return newMappings(c, namespace)
}

func (c *GetambassadorV1Client) TLSContexts(namespace string) TLSContextInterface {
	return newTLSContexts(c, namespace)
}

// NewForConfig creates a new GetambassadorV1Client for the given config.
func NewForConfig(c *rest.Config) (*GetambassadorV1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &GetambassadorV1Client{client}, nil
}

// NewForConfigOrDie creates a new GetambassadorV1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *GetambassadorV1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new GetambassadorV1Client for the given RESTClient.
func New(c rest.Interface) *GetambassadorV1Client {
	return &GetambassadorV1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *GetambassadorV1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
